<?php

namespace common\modules\sessions\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;

use common\modules\sessions\models\Session;
use common\modules\sessions\models\SessionUrl;

/**
 * SearchSession represents the model behind the search form about `common\modules\sessions\models\Session`.
 */
class SearchSessionUrl extends SessionUrl
{
    public $session;

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id', 'session_id', 'created_at', 'updated_at'], 'integer'],
            [['referer', 'url'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = SessionUrl::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'session_id' => $this->session,
            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at
        ]);

        $query->andFilterWhere(['like', 'url', $this->url])
            ->andFilterWhere(['like', 'referer', $this->referer]);

        return $dataProvider;
    }
}
